/*
 * ethd_i.h
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1996,1993,1991,1990  Arizona Board of Regents
 *
 * $Revision: 1.4 $
 * $Date: 1996/06/14 21:24:22 $
 */
#include "eth_i.h"
#include "xsim.h"
#define TRACE_ON
/* #define TRACE_CIRCULAR */
#include "evtrace.h"

#define EMAXPAK   (MAX_ETH_DATA_SZ + sizeof(ETHhdr))
#define MAX_QUEUE 240

typedef struct {
    ETHhost        ethAddr;
    int            delay;
    int            range;
    int            queueBeg, queueEnd, queueCnt;
    int            queueCntMax;
    Msg            msgQueue[MAX_QUEUE];
    int            maxPacket;
    int            hdrSize;
    int            retryCnt;
    int            retryDelay;
    int            blockCnt;
    Semaphore      waiting;
    ITrace         *traceOut;
    ITrace         *traceIn;
    TraceStruct    ts;
    unsigned short randState[3];
} PState;

extern long lrand48();
extern long nrand48(unsigned short *);
