/*
 * trace.c
 *
 * x-kernel v3.3
 *
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 *
 * $Revision: 1.2.1.1 $
 * $Date: 1994/10/28 17:37:18 $
 */

#include "platform.h"
#include "xk_debug.h"
#include "compose.h"

#ifdef XK_TRACE_LOCKING
static mutex_t lock;
#endif

void
xTraceLock(void)
{
#ifdef XK_TRACE_LOCKING
    mutex_lock( &lock );
#endif
}

void
xTraceUnlock(void)
{
#ifdef XK_TRACE_LOCKING
    mutex_unlock( &lock );
#endif
}

 

void
xTraceInit(void)
{
#ifdef XK_TRACE_LOCKING
    mutex_init(&lock , USYNC_THREAD, NULL);
    initTraceLevels();
#endif
}
