/*
 * @COPYRIGHT@
 * 
 * x-kernel v3.3
 * 
 * Copyright (c) 1993,1991,1990,1996  Arizona Board of Regents
 * 
 * @COPYRIGHT@
 *
 * $RCSfile: sprintf.c,v $
 *
 * HISTORY
 * $Log: sprintf.c,v $
 * Revision 1.5  1996/01/30  22:58:00  slm
 * Updated copyright and version.
 *
 * Revision 1.4.1.1  1994/12/03  00:06:21  hkaram
 * New branch
 *
 * Revision 1.4  1994/06/11  00:03:12  menze
 * Added copyright notice
 *
 * Revision 1.3  1994/05/14  23:49:39  davidm
 * Fixed include.
 *
 * Revision 1.2  1994/02/10  01:22:19  davidm
 * sprintf: "string" now gets properly '\0' terminated.
 *
 * Revision 1.1  1994/01/21  23:56:11  davidm
 * Initial revision
 */
#include <stdarg.h>


static void
sputchar(int ch, void *arg)
{
    char **string = (char**)arg;

    **string = ch;
    (*string)++;
} /* sputchar */


int
sprintf(char *string, const char *format, ...)
{
    va_list ap;
    int count;

    va_start(ap, format);
    count = _doprint(format, &ap, sputchar, &string);
    va_end(ap);
    *string = '\0';
    return count;
} /* sprintf */

			/*** end of sprintf.c ***/
